Oracle Coherence for C++ API
Release 3.6.0.0
E15728-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# AbstractMap Class Reference

`#include <coherence/util/AbstractMap.hpp>`

Inherits Describable, and Map.

Inherited by PofHelper::ReadableEntrySetMap, PofHelper::WriteableEntrySetMap, ContinuousQueryCache, Hashtable, SafeHashMap, and TreeMap.

List of all members.

## Detailed Description

This class provides a skeletal implementation of the `Map` interface, to minimize the effort required to implement this interface.

To implement an unmodifiable map, the programmer needs only to extend this class and provide implementations for the entrySet() and iterator() methods. Method `entrySet` returns a set-view of the map's mappings. Typically, the returned set will, in turn, be implemented atop `AbstractDeepSet`. Method `iterator` returns an entry set iterator that points to the mapping for specified key.

To implement a modifiable map, the programmer must additionally override this class's `put`, `remove` and `clear` methods (which otherwise throw an UnsupportedOperationException.

The programmer should generally provide a void (no argument) and map constructor, as per the recommendation in the `Map` interface specification.

See also:
  Map

Author:
  nsa,mf 2008.01.30

## Public Types
typedef spec::Handle | Handle
| AbstractMap Handle definition.
typedef spec::View | View
| AbstractMap View definition.
typedef spec::Holder | Holder
| AbstractMap Holder definition.
## Public Member Functions
virtual size32_t | size () const
| Return the number of key-value mappings in this map. Returns: the number of key-value mappings in this map.
virtual bool | isEmpty () const
| Return `true` if this map contains no key-value mappings. Returns: `true` if this map contains no key-value mappings.
virtual bool | containsKey (Object::View vKey) const
  | Return `true` if this map contains a mapping for the specified key. Parameters:
  | vKey | key whose presence in this map is to be tested.
Returns: `true` if this map contains a mapping for the specified key.
virtual bool | containsValue (Object::View vValue) const
  | Return `true` if this map maps one or more keys to the specified value. This operation will probably require time linear in the map size for most implementations of the `Map` interface. Parameters:
  | vValue | value whose presence in this map is to be tested.
Returns: `true` if this map maps one or more keys to the specified value.
virtual Object::Holder | get (Object::View vKey) const
  | Return the value to which this map maps the specified key. Return `NULL` if the map contains no mapping for this key. A return value of `NULL` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `NULL`. The `containsKey` operation may be used to distinguish these two cases. Parameters:
  | vKey | key whose associated value is to be returned.
Returns: the value to which this map maps the specified key, or `NULL` if the map contains no mapping for this key. See also: containsKey()
virtual Object::Holder | get (Object::View vKey)
  | Return the value to which this map maps the specified key. Return `NULL` if the map contains no mapping for this key. A return value of `NULL` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `NULL`. The `containsKey` operation may be used to distinguish these two cases. Parameters:
  | vKey | key whose associated value is to be returned.
Returns: the value to which this map maps the specified key, or `NULL` if the map contains no mapping for this key. See also: containsKey()
virtual void | putAll (Map::View vMap)
  | Copy all of the mappings from the specified map to this map. The effect of this call is equivalent to that of calling put(k, v) on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is unspecified if the specified map is modified while the operation is in progress. Parameters:
  | vMap | mappings to be stored in this map.
  Exceptions:
  | coherence::lang::UnsupportedOperationException | if the put() operation is not supported by this map.
virtual Set::View | keySet () const
| Return a set of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. Returns: a set of the keys contained in this map.
virtual Set::Handle | keySet ()
| Return a set of the keys contained in this map. The set is backed by the map, so changes to one are reflected in the other. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. Returns: a set of the keys contained in this map.
virtual Collection::View | values () const
| Return a collection of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the set. If the map is modified while an iteration over the collection is in progress, the results of the iteration are undefined. Returns: a collection of the values contained in this map.
virtual Collection::Handle | values ()
| Return a collection of the values contained in this map. The collection is backed by the map, so changes to one are reflected in the other. If the map is modified while an iteration over the collection is in progress, the results of the iteration are undefined. Returns: a collection of the values contained in this map.
virtual bool | equals (Object::View v) const
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description

The documentation for this class was generated from the following file:

- coherence/util/AbstractMap.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.